# CustomBondForce Class Reference

This class implements bonded interactions between pairs of particles. More...

Inheritance diagram for CustomBondForce:

List of all members.

## Public Member Functions

def | getNumBonds
| getNumBonds(self) -> int
def | getNumPerBondParameters
| getNumPerBondParameters(self) -> int
def | getNumGlobalParameters
| getNumGlobalParameters(self) -> int
def | getEnergyFunction
| getEnergyFunction(self) -> string
def | setEnergyFunction
| setEnergyFunction(self, string energy)
def | addPerBondParameter
| addPerBondParameter(self, string name) -> int
def | getPerBondParameterName
| getPerBondParameterName(self, int index) -> string
def | setPerBondParameterName
| setPerBondParameterName(self, int index, string name)
def | addGlobalParameter
| addGlobalParameter(self, string name, double defaultValue) -> int
def | getGlobalParameterName
| getGlobalParameterName(self, int index) -> string
def | setGlobalParameterName
| setGlobalParameterName(self, int index, string name)
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(self, int index) -> double
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(self, int index, double defaultValue)
def | addBond
| addBond(self, int particle1, int particle2, vectord parameters) -> int
def | getBondParameters
| getBondParameters(self, int index)
def | setBondParameters
| setBondParameters(self, int index, int particle1, int particle2, vectord parameters)
def | updateParametersInContext
| updateParametersInContext(self, Context context)
def | __init__
| __init__(self, string energy) -> CustomBondForce __init__(self, CustomBondForce other) -> CustomBondForce
def | __del__
| __del__(self)

## Public Attributes

| this

## Detailed Description

This class implements bonded interactions between pairs of particles.

Unlike HarmonicBondForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions. It may depend on the distance between particles, as well as on arbitrary global and per-bond parameters.

To use this class, create a CustomBondForce object, passing an algebraic expression to the constructor that defines the interaction energy between each pair of bonded particles. The expression may depend on r, the distance between the particles, as well as on any parameters you choose. Then call addPerBondParameter() to define per-bond parameters, and addGlobalParameter() to define global parameters. The values of per-bond parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context.setParameter(). Finally, call addBond() once for each bond. After a bond has been added, you can modify its parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomBondForce that implements a harmonic potential:

`CustomBondForce* force = new CustomBondForce("0.5*k*(r-r0)^2");`

This force depends on two parameters: the spring constant k and equilibrium distance r0. The following code defines these parameters:

``

    force->addPerBondParameter("k");
    force->addPerBondParameter("r0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

## Member Function Documentation

def __del__ | ( |  | self | ) |

__del__(self)

Reimplemented from Force.

def __init__ | ( |  | self,
|  |  | args |
| ) |  |  |

__init__(self, string energy) -> CustomBondForce __init__(self, CustomBondForce other) -> CustomBondForce

Create a CustomBondForce.

Parameters:

  | energy | an algebraic expression giving the interaction energy between two bonded particles as a function of r, the distance between them

def addBond | ( |  | self,
|  |  | args |
| ) |  |  |

addBond(self, int particle1, int particle2, vectord parameters) -> int

Add a bond term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the new bond

def addGlobalParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addGlobalParameter(self, string name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

def addPerBondParameter | ( |  | self,
|  |  | args |
| ) |  |  |

addPerBondParameter(self, string name) -> int

Add a new per-bond parameter that the interaction may depend on.

Parameters:

  | name | the name of the parameter

def getBondParameters | ( |  | self,
|  |  | args |
| ) |  |  |

getBondParameters(self, int index)

Get the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to get parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the bond

def getEnergyFunction | ( |  | self | ) |

getEnergyFunction(self) -> string

Get the algebraic expression that gives the interaction energy for each bond

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterDefaultValue(self, int index) -> double

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

def getGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getGlobalParameterName(self, int index) -> string

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def getNumBonds | ( |  | self | ) |

getNumBonds(self) -> int

Get the number of bonds for which force field parameters have been defined.

def getNumGlobalParameters | ( |  | self | ) |

getNumGlobalParameters(self) -> int

Get the number of global parameters that the interaction depends on.

def getNumPerBondParameters | ( |  | self | ) |

getNumPerBondParameters(self) -> int

Get the number of per-bond parameters that the interaction depends on.

def getPerBondParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

getPerBondParameterName(self, int index) -> string

Get the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to get the name

def setBondParameters | ( |  | self,
|  |  | args |
| ) |  |  |

setBondParameters(self, int index, int particle1, int particle2, vectord parameters)

Set the force field parameters for a bond term.

Parameters:

  | index | the index of the bond for which to set parameters
  | particle1 | the index of the first particle connected by the bond
  | particle2 | the index of the second particle connected by the bond
  | parameters | the list of parameters for the bond

def setEnergyFunction | ( |  | self,
|  |  | args |
| ) |  |  |

setEnergyFunction(self, string energy)

Set the algebraic expression that gives the interaction energy for each bond

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterDefaultValue(self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

def setGlobalParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setGlobalParameterName(self, int index, string name)

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def setPerBondParameterName | ( |  | self,
|  |  | args |
| ) |  |  |

setPerBondParameterName(self, int index, string name)

Set the name of a per-bond parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

def updateParametersInContext | ( |  | self,
|  |  | args |
| ) |  |  |

updateParametersInContext(self, Context context)

Update the per-bond parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-bond parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

## Member Data Documentation

this

The documentation for this class was generated from the following file:

- openmm.py